VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmLevy_Templates_Master 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Fees Templates"
   ClientHeight    =   6225
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8145
   HelpContextID   =   840
   Icon            =   "Fees Templates.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6225
   ScaleWidth      =   8145
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame Frame2 
      Caption         =   "Contents of Selected Template"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3915
      Left            =   420
      TabIndex        =   1
      Top             =   2280
      Width           =   7455
      Begin VB.CommandButton cmdHelp 
         Height          =   555
         Left            =   6720
         Picture         =   "Fees Templates.frx":0442
         Style           =   1  'Graphical
         TabIndex        =   8
         Top             =   1620
         Width           =   555
      End
      Begin VB.CommandButton cmdDeleteFee 
         Height          =   555
         Left            =   6720
         Picture         =   "Fees Templates.frx":074C
         Style           =   1  'Graphical
         TabIndex        =   7
         Top             =   960
         Width           =   555
      End
      Begin VB.CommandButton cmdInsertFee 
         Height          =   555
         Left            =   6720
         Picture         =   "Fees Templates.frx":0A56
         Style           =   1  'Graphical
         TabIndex        =   6
         Top             =   300
         Width           =   555
      End
      Begin MSFlexGridLib.MSFlexGrid grdTemplateContents 
         Height          =   3495
         Left            =   180
         TabIndex        =   3
         Top             =   300
         Width           =   6315
         _ExtentX        =   11139
         _ExtentY        =   6165
         _Version        =   393216
         Rows            =   1001
         FixedCols       =   0
         AllowBigSelection=   0   'False
         SelectionMode   =   1
         AllowUserResizing=   1
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Templates Currently Available"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1635
      Left            =   420
      TabIndex        =   0
      Top             =   300
      Width           =   7455
      Begin VB.CommandButton cmdDeleteTemplate 
         Height          =   555
         Left            =   6660
         Picture         =   "Fees Templates.frx":0D60
         Style           =   1  'Graphical
         TabIndex        =   5
         Top             =   900
         Width           =   555
      End
      Begin VB.CommandButton cmdNewTemplate 
         Height          =   555
         Left            =   6660
         Picture         =   "Fees Templates.frx":106A
         Style           =   1  'Graphical
         TabIndex        =   4
         Top             =   240
         Width           =   555
      End
      Begin VB.ListBox lstAvailableTemplates 
         Height          =   1230
         Left            =   180
         TabIndex        =   2
         Top             =   240
         Width           =   6255
      End
   End
End
Attribute VB_Name = "frmLevy_Templates_Master"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Manages the fees templates table
Option Explicit
Private Loading As Boolean
Private ArrayOfFeesInCurrTemplate() As Variant
Private blnArrayErased  As Boolean

Private Sub cmdDeleteFee_Click()
    'Removes a fee from the currently selected template
    Dim strTemplateName As String
    Dim strFeeName As String
    Dim lngFeeCode As Long
    Dim strMsg As String
    Dim lngResponse As Long
    
    
    If Not CurrentUser.Allowed_Fees_Templates_CreateNewAndModify Then
        GiveSecViolationMsg "modify templates"
    ElseIf lstAvailableTemplates.ListCount = 0 Then
        strMsg = "There are currently no templates on the system."
        MsgBox strMsg, vbExclamation, "Delete Fee"
    ElseIf lstAvailableTemplates.ListIndex = -1 Then
        strMsg = "There is currently no selected template to delete the fee from."
        MsgBox strMsg, vbExclamation, "Delete Fee"
    ElseIf grdTemplateContents.RowSel = -1 Then
        strMsg = "There is currently no fee selected for deletion"
        MsgBox strMsg, vbExclamation, "Delete Fee"
    ElseIf grdTemplateContents.Text = "" Then
        strMsg = "The cell selected at the moment does not contain any fee information."
        MsgBox strMsg, vbExclamation, "Delete Fee"
    Else
        'get fee name and template name
        strFeeName = GetGridData(grdTemplateContents, grdTemplateContents.Row, 0)
        strTemplateName = lstAvailableTemplates.List(lstAvailableTemplates.ListIndex)
        
        strMsg = "Delete the fee called " & strFeeName & " from the template called " _
               & strTemplateName
        lngResponse = MsgBox(strMsg, vbQuestion + vbYesNo, "Delete Fee")
        If lngResponse = vbYes Then
            'locate template
            rstFeesTemplates.Index = "Template Name Index"
            rstFeesTemplates.Seek "=", strTemplateName
            
            'locate fee targeted for deletion so as to get fee code
            rstRegisteredFees.Index = "Fee Name Index"
            rstRegisteredFees.Seek "=", strFeeName
            
            If rstFeesTemplates.NoMatch Then
                strMsg = "Fee not deleted because the template could not be located"
                MsgBox strMsg, vbCritical, "Delete Fee"
            ElseIf rstRegisteredFees.NoMatch Then
                strMsg = "Fee not delted because it could not be located"
                MsgBox strMsg, vbCritical, "Delete Fee"
            Else
                lngFeeCode = rstRegisteredFees("Fee Code")
                'update the array
                RemoveFeeCodeFromArray (lngFeeCode)
                'write the array to the table
                UpdateTemplatesTable
                'reload record
                UpdateGridControl
                MsgBox "Fee successfully deleted from template", vbInformation, "Delete Fee"
            End If
        End If
    End If
    
End Sub

Private Sub RemoveFeeCodeFromArray(lngFeeCode)
    'removes the fee code and its associated amount from the array of fees for
    'the current template. Adjusts array size.
    'May set global variable blnArrayErased if the deletion results in an empty array
    Dim lngCounter As Long
    Dim intCounter As Long
    Dim lngNewCols As Long
    
    If UBound(ArrayOfFeesInCurrTemplate, 2) > 1 Then
        For lngCounter = 1 To UBound(ArrayOfFeesInCurrTemplate, 2) - 1
            If ArrayOfFeesInCurrTemplate(1, lngCounter) = lngFeeCode Then
                'move all rows below current one 1 row up effectively erasing row
                For intCounter = lngCounter + 1 To UBound(ArrayOfFeesInCurrTemplate, 2)
                    ArrayOfFeesInCurrTemplate(1, intCounter - 1) = ArrayOfFeesInCurrTemplate(1, intCounter)
                    ArrayOfFeesInCurrTemplate(2, intCounter - 1) = ArrayOfFeesInCurrTemplate(2, intCounter)
                Next
                Exit For
            End If
        Next
    End If
    
    lngNewCols = UBound(ArrayOfFeesInCurrTemplate, 2) - 1
    If lngNewCols = 0 Then
        blnArrayErased = True
    Else
        ReDim Preserve ArrayOfFeesInCurrTemplate(1 To 2, 1 To lngNewCols)
    End If
        
End Sub

Private Sub UpdateTemplatesTable()
    'copies array to the current record of the templates table
    Dim lngCounter As Long
    Dim strText As String
        
    If IsEmpty(ArrayOfFeesInCurrTemplate) Or blnArrayErased Then
        strText = ""
    Else
        'Build insertion
        For lngCounter = 1 To UBound(ArrayOfFeesInCurrTemplate, 2)
            strText = strText & Trim(Str(ArrayOfFeesInCurrTemplate(1, lngCounter))) & "," _
                    & Trim(Str(ArrayOfFeesInCurrTemplate(2, lngCounter))) & ";"
        Next
    End If
    
    'update record
    rstFeesTemplates.Edit
        rstFeesTemplates("Template Data") = strText
    rstFeesTemplates.Update
    
    
End Sub

Private Sub cmdDeleteTemplate_Click()
    If CurrentUser.Allowed_Fees_Templates_Delete Then
        DeleteTemplate
    Else
        GiveSecViolationMsg "delete fees templates"
    End If
    
End Sub

Private Sub DeleteTemplate()
    'Deletes an entire template
    Dim strTemplateName As String
    Dim strMsg As String
    Dim lngResponse As Long
    
    If lstAvailableTemplates.ListCount = 0 Then
        strMsg = " There are currently no registered templates."
        MsgBox strMsg, vbExclamation, "Delete Template"
    ElseIf lstAvailableTemplates.ListIndex = -1 Then
        strMsg = " There is currently no template selected for deletion"
        MsgBox strMsg, vbExclamation, "Delete Template"
    Else
        'confirm deletion
        strMsg = "Are you sure you want to delete the selected template"
        lngResponse = MsgBox(strMsg, vbYesNo + vbQuestion, "Delete Template")
        If lngResponse = vbYes Then
            'get template name
            strTemplateName = lstAvailableTemplates.List(lstAvailableTemplates.ListIndex)
            
            'locate template
            rstFeesTemplates.Index = "Template Name Index"
            rstFeesTemplates.Seek "=", strTemplateName
            
            If rstFeesTemplates.NoMatch Then
                strMsg = "Unable to delete the selected template because it could not be found"
                MsgBox strMsg, vbCritical, "System Error"
            Else
                'delete template
                rstFeesTemplates.Delete
                'update displayed list of templates
                LoadListOfAvailableTemplates
                'display contents of current template
                UpdateGridControl
            End If
        End If
    End If
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 840
End Sub

Private Sub cmdInsertFee_Click()
    'Adds a registered fee to a template
    Dim strMsg As String
    
    If Not CurrentUser.Allowed_Fees_Templates_CreateNewAndModify Then
        GiveSecViolationMsg "modify templates"
    ElseIf lstAvailableTemplates.ListCount = 0 Then
        strMsg = "There are currently no templates on the system."
        MsgBox strMsg, vbExclamation, "Insert Fee"
    ElseIf lstAvailableTemplates.ListIndex = -1 Then
        strMsg = "There is currently no selected template to place the fee in."
        MsgBox strMsg, vbExclamation, "Insert Fee"
    Else
        'Delegate task
        frmLevy_Templates_InsertFee.Show vbModal
        'update display
        UpdateGridControl
    End If
    
End Sub


Private Sub cmdNewTemplate_Click()
    If CurrentUser.Allowed_Fees_Templates_CreateNewAndModify Then
        CreateNewTemplate
    Else
        GiveSecViolationMsg "create new templates"
    End If
    
End Sub

Private Sub CreateNewTemplate()
    'Create a new blank template
    Dim strMsg As String
    Dim strTemplateName As String
    
    'get template name
    strMsg = "Enter the name of the template. " & strNewLine _
           & "The length of this name must not exceed 30 characters."
    strTemplateName = InputBox(strMsg, "Register New Template")
    
    'verify uniqueness of supplied name
    rstFeesTemplates.Index = "Template Name Index"
    rstFeesTemplates.Seek "=", strTemplateName
    
    If strTemplateName = "" Then
        strMsg = "Did not create a template because no name was supplied"
        MsgBox strMsg, vbExclamation, "Register New Template"
    ElseIf Not (rstFeesTemplates.NoMatch) Then
        strMsg = "A template by that name already exist. Please choose another name"
        MsgBox strMsg, vbExclamation, "Register New Template"
    Else
        'create template
        rstFeesTemplates.AddNew
            rstFeesTemplates("Template Name") = strTemplateName
            rstFeesTemplates("Template Data") = ""
        rstFeesTemplates.Update
        'issue confirmation of success
        strMsg = "Template successfully created"
        MsgBox strMsg, vbExclamation, "Register New Template"
        'Update display
        LoadListOfAvailableTemplates
        'Select the most recntly inserted template in the form
        Call SelectListItem(lstAvailableTemplates, strTemplateName)
        'Update the display to reflect the coontents of the selected template
        UpdateGridControl
    End If
    
End Sub

Private Sub SelectListItem(objListBox As ListBox, strListItem As String)
    'Select the list item in the
    Dim blnItemFound As Boolean
    Dim lngCounter As Long
    
    Do
        If TextTheSame(objListBox.List(lngCounter), strListItem) Then
            objListBox.ListIndex = lngCounter
            blnItemFound = True
        End If
        lngCounter = lngCounter + 1
    Loop Until lngCounter = lstAvailableTemplates.ListCount - 1 Or blnItemFound
    
End Sub

Private Sub Form_Activate()
    
    If Loading = True Then
        Loading = False
        If rstRegisteredFees.RecordCount = 0 Then
            MsgBox "Please register some fees first", vbExclamation, "Fees Templates"
            Unload Me
        Else
            initialiseGrid
            If rstFeesTemplates.RecordCount <> 0 Then
                LoadListOfAvailableTemplates
                lstAvailableTemplates.ListIndex = 0
                UpdateGridControl
            End If
        End If
    End If
    
End Sub

Private Sub initialiseGrid()
        
        grdTemplateContents.ColWidth(0) = 3795
        grdTemplateContents.ColWidth(1) = 2205
        
        
        grdTemplateContents.Row = 0
        grdTemplateContents.Col = 0
        grdTemplateContents.Text = "Fee Name"
        grdTemplateContents.ColAlignment(0) = flexAlignLeftCenter
        
        
        grdTemplateContents.Col = 1
        grdTemplateContents.Text = "Amount ($)"
        grdTemplateContents.ColAlignment(1) = flexAlignRightCenter
        grdTemplateContents.FixedAlignment(1) = flexAlignCenterCenter

End Sub

Private Sub Form_Load()
    
    Loading = True
    
End Sub

Private Sub LoadListOfAvailableTemplates()
    'Inserts all the templates listed in the Template Table into the lis of
    'available templates
    
    Dim lngCounter As Long
    'Clear list first
    lstAvailableTemplates.Clear
        
    'Ensure that table is not empty first
    If rstFeesTemplates.RecordCount <> 0 Then
        rstFeesTemplates.MoveFirst
        For lngCounter = 1 To rstFeesTemplates.RecordCount
            lstAvailableTemplates.AddItem rstFeesTemplates("Template Name")
            rstFeesTemplates.MoveNext
        Next
    End If
        
    
End Sub

Private Sub lstAvailableTemplates_Click()

    If lstAvailableTemplates.ListIndex <> -1 Then
        Erase ArrayOfFeesInCurrTemplate
        blnArrayErased = True
        UpdateGridControl
    End If

End Sub


Private Sub UpdateGridControl()
    Dim strMsg As String
    Dim strTemplateName As String
    Dim strTemplateData As String
    
    'blank out grid first
    grdTemplateContents.Clear
    initialiseGrid
    
    'ensure that a template has been selected first
    If lstAvailableTemplates.ListIndex <> -1 Then
        'get name of currently selected template
        strTemplateName = lstAvailableTemplates.List(lstAvailableTemplates.ListIndex)
        
        'locate template in table
        rstFeesTemplates.Index = "Template Name Index"
        rstFeesTemplates.Seek "=", strTemplateName
        
        If rstFeesTemplates.NoMatch Then
            strMsg = "Unable to update grid because the selected template could not be located"
            MsgBox strMsg, vbCritical, "System Error"
        Else
            'retrieve template contents
            strTemplateData = rstFeesTemplates("Template Data")
            If strTemplateData <> "" Then
                'Generate the array of the fees in the current template
                Generate_ArrayOfFeesInCurrTemplate (strTemplateData)
                'Write the array to the grid
                WriteTemplateArrayContentsToGrid
            End If
        End If
    End If
            
            
        
End Sub

Private Sub Generate_ArrayOfFeesInCurrTemplate(strTemplateData)
    Dim lngCurrentPosition As Long
    Dim strCurrentCharacter As String * 1
    Dim lngLastPosition As Long
    Dim strTemp As String
    Dim lngArrayEntries As Long
    
        
    lngCurrentPosition = 1
    lngLastPosition = 1
    
    blnArrayErased = False
    Do
        strCurrentCharacter = Mid(strTemplateData, lngCurrentPosition, 1)
        If strCurrentCharacter = "," Then
            'Fee Code termonation found; Add row to array
            lngArrayEntries = lngArrayEntries + 1
            ReDim Preserve ArrayOfFeesInCurrTemplate(1 To 2, 1 To lngArrayEntries)
            'Rip Out Fee Code
            strTemp = Mid(strTemplateData, lngLastPosition, lngCurrentPosition - lngLastPosition)
            'Insert Fee Code
            ArrayOfFeesInCurrTemplate(1, lngArrayEntries) = Val(strTemp)
            'Mark start position of next rip
            lngLastPosition = lngCurrentPosition + 1
        ElseIf strCurrentCharacter = ";" Then
            'Fee Amount termination found
            'Rip out fee amount
            strTemp = Mid(strTemplateData, lngLastPosition, lngCurrentPosition - lngLastPosition)
            'Insert amount into current array row
            ArrayOfFeesInCurrTemplate(2, lngArrayEntries) = Val(strTemp)
            'Mark start position of next read
            lngLastPosition = lngCurrentPosition + 1
        End If
        'prepare to read next character
        lngCurrentPosition = lngCurrentPosition + 1
    Loop Until lngCurrentPosition > Len(strTemplateData)
            
End Sub

Private Sub WriteTemplateArrayContentsToGrid()
    Dim lngRowCounter As Long
    Dim strFeeName As String
    Dim strFeeAmount As String
    Dim strMsg As String
    
    
    rstRegisteredFees.Index = "Fee Code Index"   'Used to retrieve fee names
    For lngRowCounter = 1 To UBound(ArrayOfFeesInCurrTemplate, 2)
        grdTemplateContents.Row = lngRowCounter
        
        'Get fee name
        rstRegisteredFees.Seek "=", ArrayOfFeesInCurrTemplate(1, lngRowCounter)
        If rstRegisteredFees.NoMatch Then
            strMsg = "This fee contains a record to a fee that is not registered. " _
                   & "This error cannot be fixed. Please delete the template."
            MsgBox strMsg, vbCritical, "System Error"
            Exit For
        Else
            strFeeName = rstRegisteredFees("Fee Name")
        End If
        grdTemplateContents.Col = 0
        grdTemplateContents.Text = strFeeName
        
        strFeeAmount = Format(ArrayOfFeesInCurrTemplate(2, lngRowCounter), "### ### ##0.00")
        grdTemplateContents.Col = 1
        grdTemplateContents.Text = strFeeAmount
    Next
    
End Sub

